//Генерация случайных чисел на поддиапазонах с равномерным законом распределения
function [Functions..//Функции с параметрами в виде cell-массива списков
          ]=ParametrsFunctionsStrsParse(strFunctionsNames,..//Строка имен функций
                                        strFunctionsParametrs..//Строка параметров функций
                                        )
    //Проверяем агрументы
    select argn(2)
    case 0 then
        strFunctionsNames = [];//Строка имен функций по умолчанию пустая 
        strFunctionsParametrs = [];//Строка параметров функций по умолчанию пустая
    case 1 then
        strFunctionsParametrs = [];//Строка параметров функций по умолчанию пустая
    end
    
    //Обрабатываем случай пустой строки функций
    if isempty(strFunctionsNames) then
        Functions = cell();
        
        return;
    end
    
    //Проверяем корректность аргументов
    if type(strFunctionsNames) ~= 10 then
        error('The argument strFunctionsNames of function ParametrsFunctionsStrsParse must be matrix 1xM of string');
    end
    if (~isempty(strFunctionsParametrs)) &&..
       (type(strFunctionsParametrs) ~= 10) then
        error('The argument strFunctionsParametrs of function ParametrsFunctionsStrsParse must be matrix 1xM of string');
    end
    strFunctionsNames = matrix(strFunctionsNames,1,-1);//Приводим имена функций к матрице-строке
    strFunctionsParametrs = matrix(strFunctionsParametrs,1,-1);//Приводим имена параметров функции к матрице-строке
    nFunctions = size(strFunctionsNames,'*');//Число функций
    nFunctionsParametrs = size(strFunctionsParametrs,'*');//Число параметров функций
    if nFunctions < nFunctionsParametrs then
        strFunctionsNames = [strFunctionsNames,repmat(strFunctionsNames($),[1,nFunctionsParametrs - nFunctions])];
        nFunctions = nFunctionsParametrs;
    elseif (nFunctionsParametrs < nFunctions) &&..
           (nFunctionsParametrs > 0) then
        strFunctionsParametrs = [strFunctionsParametrs,repmat(strFunctionsParametrs($),[1,nFunctions - nFunctionsParametrs])];
    end
    
    //Приводим к cell-массиву функций с параметрами
    Functions = cell(1,nFunctions);//Создаем пустой cell-массив функций
    strFunctionsNames = '""' + strFunctionsNames + '""';//Обрамляем кавычками иена функций
    ind = [1:nFunctions];//Индексы функций
    if nFunctionsParametrs > 0 then
        indListFun = (length(FunctionsParametrs) > 0);//Индексы функций с параметрами
        indFun = ~indListFun;//Индексы функций без параметров
        if or(indListFun) then
            execstr('Functions{' + string(ind(indListFun)) + '} = list(' + strFunctionsNames(indListFun) + ',' + strFunctionsParametrs(indListFun) + ')');//Парсим функции
        end
        if or(indFun) then
            execstr('Functions{' + string(ind(indFun)) + '} = ' + strFunctionsNames(indFun));//Парсим функции
        end
    else
        execstr('Functions{' + string(ind) + '} = ' + strFunctionsNames);//Парсим функции
    end
endfunction
