//Генерация случайных чисел на поддиапазонах с равномерным законом распределения
function [randomValues,..//Случайные величины
          randomValuesHeaders,..//Заголовки случайных величин
          randomValuesMin,..//Минимальные значения случайных величин
          randomValuesMax..//Максимальные значения случайных величин
          ]=RandomGenerateUniformOnRangesFile(IsHeadersUniformRandomValuesAttributes,..//Факт наличия заголовков случайных данных в файле аттрибутов
                                              nValues,..//Число генерируемых величин
                                              UniformRandomValuesAttributesFileName,..//Имя файла аттрибутов равномерно распределенных случайных величин
                                              UniformRandomValuesGenerateAttributesFileName,..//Имя файла аттрибутов равномерно распределенных случайных величин
                                              randomValuesFileName,..//Имя файла случайных величин
                                              csvSeparator,..//.csv-разделитель
                                              csvDec..//Десятичный разделитель
                                              )
    //Проверяем агрументы
    select argn(2)
    case 0 then
        error('The function RandomGenerateUniformOnRangesFile takes 1 - 7 arguments');
    case 1 then
        UniformRandomValuesAttributesFileName = IsHeadersUniformRandomValuesAttributes;
        nValues = [];//Число генерируемых совокупностей случайных величин по умолчанию берем пустым
        IsHeadersUniformRandomValuesAttributes = %t;//По умолчанию чиатем с заголовком
        UniformRandomValuesGenerateAttributesFileName = [];//По умолчанию аттрибуты генерации берем по умолчанию
        randomValuesFileName = [];//По умолчанию случайные величины не сохраняем в файл
        csvSeparator = ',';//.csv-разделитель по умолчанию берем запятую
        csvDec = '.';//Десятичный разделитель по умолчанию берем точкой
    case 2 then
        select type(IsHeadersUniformRandomValuesAttributes)
        case 4 then
            UniformRandomValuesAttributesFileName = nValues;
            nValues = [];//Число генерируемых совокупностей случайных величин по умолчанию берем пустым
            UniformRandomValuesGenerateAttributesFileName = [];//По умолчанию аттрибуты генерации берем по умолчанию
        case 1 then
            UniformRandomValuesAttributesFileName = nValues;
            nValues = IsHeadersUniformRandomValuesAttributes;
            IsHeadersUniformRandomValuesAttributes = %t;//По умолчанию читаем с заголовком
            UniformRandomValuesGenerateAttributesFileName = [];//По умолчанию аттрибуты генерации берем по умолчанию
        else
            UniformRandomValuesGenerateAttributesFileName = nValues;
            UniformRandomValuesAttributesFileName = IsHeadersUniformRandomValuesAttributes;
            nValues = [];//Число генерируемых совокупностей случайных величин по умолчанию берем пустым
            IsHeadersUniformRandomValuesAttributes = %t;//По умолчанию чиатем с заголовком
        end
        randomValuesFileName = [];//По умолчанию случайные величины не сохраняем в файл
        csvSeparator = ',';//.csv-разделитель по умолчанию берем запятую
        csvDec = '.';//Десятичный разделитель по умолчанию берем точкой
    case 3 then
        select type(IsHeadersUniformRandomValuesAttributes)
        case 4 then
            if type(nValues) == 1 then
                UniformRandomValuesGenerateAttributesFileName = [];//По умолчанию аттрибуты генерации берем по умолчанию
            else
                UniformRandomValuesGenerateAttributesFileName = UniformRandomValuesAttributesFileName;
                UniformRandomValuesAttributesFileName = nValues;
                nValues = [];//Число генерируемых совокупностей случайных величин по умолчанию берем пустым
            end
            randomValuesFileName = [];//По умолчанию случайные величины не сохраняем в файл
        case 1 then
            UniformRandomValuesGenerateAttributesFileName = UniformRandomValuesAttributesFileName;
            UniformRandomValuesAttributesFileName = nValues;
            nValues = IsHeadersUniformRandomValuesAttributes;
            IsHeadersUniformRandomValuesAttributes = %t;//По умолчанию чиатем с заголовком
        else
            randomValuesFileName = UniformRandomValuesAttributesFileName;
            UniformRandomValuesGenerateAttributesFileName = nValues;//По умолчанию аттрибуты генерации берем по умолчанию
            UniformRandomValuesAttributesFileName = IsHeadersUniformRandomValuesAttributes;//По умолчанию случайные величины не сохраняем в файл
            nValues = [];//Число генерируемых совокупностей случайных величин по умолчанию берем пустым
            IsHeadersUniformRandomValuesAttributes = %t;//По умолчанию чиатем с заголовком
        end
        csvSeparator = ',';//.csv-разделитель по умолчанию берем запятую
        csvDec = '.';//Десятичный разделитель по умолчанию берем точкой
    case 4 then
        select type(IsHeadersUniformRandomValuesAttributes)
        case 4 then
            if type(nValues) == 1 then
                randomValuesFileName = [];//По умолчанию случайные величины не сохраняем в файл
            else
                randomValuesFileName = UniformRandomValuesGenerateAttributesFileName;
                UniformRandomValuesGenerateAttributesFileName = UniformRandomValuesAttributesFileName;
                UniformRandomValuesAttributesFileName = nValues;
                nValues = [];//Число генерируемых совокупностей случайных величин по умолчанию берем пустым
            end
            csvSeparator = ',';//.csv-разделитель по умолчанию берем запятую
        case 1 then
            randomValuesFileName = UniformRandomValuesGenerateAttributesFileName;
            UniformRandomValuesGenerateAttributesFileName = UniformRandomValuesAttributesFileName;
            UniformRandomValuesAttributesFileName = nValues;
            nValues = IsHeadersUniformRandomValuesAttributes;
            IsHeadersUniformRandomValuesAttributes = %t;//По умолчанию чиатем с заголовком
            csvSeparator = ',';//.csv-разделитель по умолчанию берем запятую
        else
            csvSeparator = UniformRandomValuesGenerateAttributesFileName;
            randomValuesFileName = UniformRandomValuesAttributesFileName;
            UniformRandomValuesGenerateAttributesFileName = nValues;
            UniformRandomValuesAttributesFileName = IsHeadersUniformRandomValuesAttributes;
            nValues = [];//Число генерируемых совокупностей случайных величин по умолчанию берем пустым
            IsHeadersUniformRandomValuesAttributes = %t;//По умолчанию чиатем с заголовком
        end
        csvDec = '.';//Десятичный разделитель по умолчанию берем точкой
    case 5 then
        select type(IsHeadersUniformRandomValuesAttributes)
        case 4 then
            if type(nValues) == 1 then
                csvSeparator = ',';//.csv-разделитель по умолчанию берем запятую
            else
                csvSeparator = randomValuesFileName;
                randomValuesFileName = UniformRandomValuesGenerateAttributesFileName;
                UniformRandomValuesGenerateAttributesFileName = UniformRandomValuesAttributesFileName;
                UniformRandomValuesAttributesFileName = nValues;
                nValues = [];//Число генерируемых совокупностей случайных величин по умолчанию берем пустым
            end
            csvDec = '.';//Десятичный разделитель по умолчанию берем точкой
        case 1 then
            csvSeparator = randomValuesFileName;
            randomValuesFileName = UniformRandomValuesGenerateAttributesFileName;
            UniformRandomValuesGenerateAttributesFileName = UniformRandomValuesAttributesFileName;
            UniformRandomValuesAttributesFileName = nValues;
            nValues = IsHeadersUniformRandomValuesAttributes;
            IsHeadersUniformRandomValuesAttributes = %t;//По умолчанию чиатем с заголовком
            csvDec = '.';//Десятичный разделитель по умолчанию берем точкой
        else
            csvDec = randomValuesFileName;
            csvSeparator = UniformRandomValuesGenerateAttributesFileName;
            randomValuesFileName = UniformRandomValuesAttributesFileName;
            UniformRandomValuesGenerateAttributesFileName = nValues;
            UniformRandomValuesAttributesFileName = IsHeadersUniformRandomValuesAttributes;
            nValues = [];//Число генерируемых совокупностей случайных величин по умолчанию берем пустым
            IsHeadersUniformRandomValuesAttributes = %t;//По умолчанию чиатем с заголовком
        end
    case 6 then
        if type(IsHeadersUniformRandomValuesAttributes) == 1 then
            csvDec = csvSeparator;
            csvSeparator = randomValuesFileName;
            randomValuesFileName = UniformRandomValuesGenerateAttributesFileName;
            UniformRandomValuesGenerateAttributesFileName = UniformRandomValuesAttributesFileName;
            UniformRandomValuesAttributesFileName = nValues;
            nValues = IsHeadersUniformRandomValuesAttributes;
            IsHeadersUniformRandomValuesAttributes = %t;//По умолчанию чиатем с заголовком
        elseif type(nValues) == 10 then
            csvDec = csvSeparator;
            csvSeparator = randomValuesFileName;
            randomValuesFileName = UniformRandomValuesGenerateAttributesFileName;
            UniformRandomValuesGenerateAttributesFileName = UniformRandomValuesAttributesFileName;
            UniformRandomValuesAttributesFileName = nValues;
            nValues = [];//Число генерируемых совокупностей случайных величин по умолчанию берем пустым
        else
            csvDec = '.';//Десятичный разделитель по умолчанию берем точкой
        end
    end
    
    //Считываем аттрибуты равномерно распределенных генерируемых данных
    [randomValuesHeaders,..//Заголовки случайных величин
     randomValuesMin,..//Минимальные значения случайных величин
     randomValuesMax..//Максимальные значения случайных величин
     ]=UniformRandomValuesAttributesParse(IsHeadersUniformRandomValuesAttributes,..//Факт наличия заголовков случайных данных
                                          UniformRandomValuesAttributesFileName,..//Имя файла аттрибутов равномерно распределенных случайных величин
                                          csvSeparator,..//.csv-разделитель
                                          csvDec..//Десятичный разделитель
                                          );

    //Считываем аттрибуты генерации равномерно распределенных данных
    [_nValues,..//Число сгенерированных совокупностей случайных величин
     typeGenetate,..//Тип генерации
     PredicateFunction,..//Функция предиката
     PredicateFunctionArgumentHeaders,..//Заголовки аргументов функции предиката
     isPredicateVectorized..//Векторизован ли предикат
     ]=UniformRandomValuesGenerateAttributesParse(UniformRandomValuesGenerateAttributesFileName,..//Имя файла аттрибутов равномерно распределенных случайных величин
                                                  csvSeparator..//.csv-разделитель
                                                  );
    if isempty(nValues) then
        nValues = _nValues;
    end
    
    //Генерируем случайные значения
    [randomValues,..//Случайные величины
     randomValuesMin,..//Минимальные значения случайных величин
     randomValuesMax..//Максимальные значения случайных величин
     ]=RandomGenerateUniformOnRangesSave(randomValuesHeaders,..//Заголовки случайных величин
                                         randomValuesMin,..//Минимальные значения случайных величин
                                         randomValuesMax,..//Максимальные значения случайных величин
                                         nValues,..//Число сгенерированных совокупностей случайных величин
                                         typeGenetate,..//Тип генерации
                                         PredicateFunction,..//Функция предиката
                                         PredicateFunctionArgumentHeaders,..//Заголовки аргументов функции предиката
                                         randomValuesFileName,..//Имя файла случайных величин
                                         csvSeparator,..//.csv-разделитель
                                         csvDec,..//Десятичный разделитель
                                         isPredicateVectorized..//Векторизован ли предикат
                                         );
endfunction
