//Генерация случайных чисел на поддиапазонах с равномерным законом распределения
function [randomValues,..//Случайные величины
          randomValuesMin,..//Минимальные значения случайных величин
          randomValuesMax..//Максимальные значения случайных величин
          ]=RandomGenerateUniformOnRangesSave(randomValuesHeaders,..//Заголовки случайных величин
                                              randomValuesMin,..//Минимальные значения случайных величин
                                              randomValuesMax,..//Максимальные значения случайных величин
                                              nValues,..//Число сгенерированных совокупностей случайных величин
                                              typeGenetate,..//Тип генерации
                                              PredicateFunction,..//Функция предиката
                                              PredicateFunctionArgumentHeaders,..//Заголовки аргументов функции предиката
                                              randomValuesFileName,..//Имя файла случайных величин
                                              csvSeparator,..//.csv-разделитель
                                              csvDec,..//Десятичный разделитель
                                              isPredicateVectorized..//Векторизован ли предикат
                                              )
    //Проверяем агрументы
    nArg = argn(2);//Числа аргументов
    if nArg < 2 then
        error('The function RandomGenerateUniformOnRangesSave takes 2 - 11 arguments');
    end
    select nArg
    case 2 then
        randomValuesMax = randomValuesMin;
        randomValuesMin = randomValuesHeaders;
        randomValuesHeaders = [];
        nValues = 1;//По умолчанию генерируем одну совокупность случайных величин
        typeGenetate = 0;//Тип генерации по умолчанию ноль
        PredicateFunction = [];//Функция предиката по умолчанию пустая
        PredicateFunctionArgumentHeaders = [];//Заголовки аргументов функции предиката по умолчанию пустые
        randomValuesFileName = [];//Имя файла случайных величин по умолчанию пустое
        csvSeparator = ',';//.csv-разделитель по умолчанию запятая
        csvDec = '.';//Десятичный разделитель по умолчанию точка
        isPredicateVectorized = %t;//По умолчанию предикат векторизован
    case 3 then
        if isempty(randomValuesHeaders) ||..
           (type(randomValuesHeaders) == 10) then
            nValues = 1;//По умолчанию генерируем одну совокупность случайных величин
            randomValuesFileName = [];//Имя файла случайных величин по умолчанию пустое
        else
            if type(randomValuesMax) == 10 then
                randomValuesFileName = randomValuesMax;
                nValues = 1;//По умолчанию генерируем одну совокупность случайных величин
            else
                nValues = randomValuesMax;
                randomValuesFileName = [];//Имя файла случайных величин по умолчанию пустое
            end
            randomValuesMax = randomValuesMin;
            randomValuesMin = randomValuesHeaders;
            randomValuesHeaders = [];
        end
        typeGenetate = 0;//Тип генерации по умолчанию ноль
        PredicateFunction = [];//Функция предиката по умолчанию пустая
        PredicateFunctionArgumentHeaders = [];//Заголовки аргументов функции предиката по умолчанию пустые
        csvSeparator = ',';//.csv-разделитель по умолчанию запятая
        csvDec = '.';//Десятичный разделитель по умолчанию точка
        isPredicateVectorized = %t;//По умолчанию предикат векторизован
    case 4 then
        if isempty(randomValuesHeaders) ||..
           (type(randomValuesHeaders) == 10) then
            if type(nValues) == 10 then
                randomValuesFileName = nValues;
                nValues = 1;//По умолчанию генерируем одну совокупность случайных величин
            else
                randomValuesFileName = [];//Имя файла случайных величин по умолчанию пустое
            end
            typeGenetate = 0;//Тип генерации по умолчанию ноль
            PredicateFunction = [];//Функция предиката по умолчанию пустая
            csvSeparator = ',';//.csv-разделитель по умолчанию запятая
        else
            if type(randomValuesMax) == 10 then
                randomValuesFileName = randomValuesMax;
                csvSeparator = nValues;
                nValues = 1;//По умолчанию генерируем одну совокупность случайных величин
                typeGenetate = 0;//Тип генерации по умолчанию ноль
                PredicateFunction = [];//Функция предиката по умолчанию пустая
            else
                if type(nValues) == 10 then
                    randomValuesFileName = nValues;
                    nValues = 1;//По умолчанию генерируем одну совокупность случайных величин
                    typeGenetate = 0;//Тип генерации по умолчанию ноль
                    PredicateFunction = [];//Функция предиката по умолчанию пустая
                else
                    if IsCountFunction(nValues) then
                        PredicateFunction = nValues;
                        typeGenetate = 0;//Тип генерации по умолчанию ноль
                    else
                        typeGenetate = nValues;
                        PredicateFunction = [];//Функция предиката по умолчанию пустая
                    end
                    nValues = randomValuesMax;
                    randomValuesFileName = [];//Имя файла случайных величин по умолчанию пустое
                end
                csvSeparator = ',';//.csv-разделитель по умолчанию запятая
            end
            randomValuesMax = randomValuesMin;
            randomValuesMin = randomValuesHeaders;
            randomValuesHeaders = [];
        end
        PredicateFunctionArgumentHeaders = [];//Заголовки аргументов функции предиката по умолчанию пустые
        csvDec = '.';//Десятичный разделитель по умолчанию точка
        isPredicateVectorized = %t;//По умолчанию предикат векторизован
    case 5 then
        if isempty(randomValuesHeaders) ||..
           (type(randomValuesHeaders) == 10) then
            if type(nValues) == 10 then
                randomValuesFileName = nValues;
                csvSeparator = typeGenetate;
                nValues = 1;//По умолчанию генерируем одну совокупность случайных величин
                typeGenetate = 0;//Тип генерации по умолчанию ноль
                PredicateFunction = [];//Функция предиката по умолчанию пустая
            elseif type(typeGenetate) == 10 then
                randomValuesFileName = typeGenetate;
                typeGenetate = 0;//Тип генерации по умолчанию ноль
                PredicateFunction = [];//Функция предиката по умолчанию пустая
                csvSeparator = ',';//.csv-разделитель по умолчанию запятая
            elseif IsCountFunction(typeGenetate) then
                PredicateFunction = typeGenetate;
                typeGenetate = 0;//Тип генерации по умолчанию ноль
                randomValuesFileName = [];//Имя файла случайных величин по умолчанию пустое
                csvSeparator = ',';//.csv-разделитель по умолчанию запятая
            else
                PredicateFunction = [];//Функция предиката по умолчанию пустая
                randomValuesFileName = [];//Имя файла случайных величин по умолчанию пустое
                csvSeparator = ',';//.csv-разделитель по умолчанию запятая
            end
            csvDec = '.';//Десятичный разделитель по умолчанию точка
        else
            if type(randomValuesMax) == 10 then
                randomValuesFileName = randomValuesMax;
                csvSeparator = nValues;
                csvDec = typeGenetate;
                nValues = 1;//По умолчанию генерируем одну совокупность случайных величин
                typeGenetate = 0;//Тип генерации по умолчанию ноль
                PredicateFunction = [];//Функция предиката по умолчанию пустая
            elseif type(nValues) == 10 then
                randomValuesFileName = nValues;
                csvSeparator = typeGenetate;
                nValues = randomValuesMax;//По умолчанию генерируем одну совокупность случайных величин
                typeGenetate = 0;//Тип генерации по умолчанию ноль
                PredicateFunction = [];//Функция предиката по умолчанию пустая
                csvDec = '.';//Десятичный разделитель по умолчанию точка
            elseif type(typeGenetate) == 10 then
                randomValuesFileName = typeGenetate;
                typeGenetate = 0;//Тип генерации по умолчанию ноль
                PredicateFunction = [];//Функция предиката по умолчанию пустая
                csvSeparator = ',';//.csv-разделитель по умолчанию запятая
                csvDec = '.';//Десятичный разделитель по умолчанию точка
            else
                PredicateFunction = typeGenetate;
                typeGenetate = nValues;
                nValues = randomValuesMax;
                randomValuesFileName = [];//Имя файла случайных величин по умолчанию пустое
                csvSeparator = ',';//.csv-разделитель по умолчанию запятая
                csvDec = '.';//Десятичный разделитель по умолчанию точка
            end
            randomValuesMax = randomValuesMin;
            randomValuesMin = randomValuesHeaders;
            randomValuesHeaders = [];
        end
        PredicateFunctionArgumentHeaders = [];//Заголовки аргументов функции предиката по умолчанию пустые
        isPredicateVectorized = %t;//По умолчанию предикат векторизован
    case 6 then
        if isempty(randomValuesHeaders) ||..
           (type(randomValuesHeaders) == 10) then
            if type(nValues) == 10 then
                randomValuesFileName = nValues;
                csvSeparator = typeGenetate;
                csvDec = PredicateFunction;
                nValues = 1;//По умолчанию генерируем одну совокупность случайных величин
                typeGenetate = 0;//Тип генерации по умолчанию ноль
                PredicateFunction = [];//Функция предиката по умолчанию пустая
            else
                if type(typeGenetate) == 10 then
                    randomValuesFileName = typeGenetate;
                    csvSeparator = PredicateFunction;
                    typeGenetate = 0;//Тип генерации по умолчанию ноль
                    PredicateFunction = [];//Функция предиката по умолчанию пустая
                else
                    if type(PredicateFunction) == 10 then
                        randomValuesFileName = PredicateFunction;
                        PredicateFunction = [];//Функция предиката по умолчанию пустая
                    else
                        if IsCountFunction(typeGenetate) then
                            PredicateFunction = typeGenetate;
                            typeGenetate = 0;//Тип генерации по умолчанию ноль
                        end
                        randomValuesFileName = [];//Имя файла случайных величин по умолчанию пустое
                    end
                    csvSeparator = ',';//.csv-разделитель по умолчанию запятая
                end
                csvDec = '.';//Десятичный разделитель по умолчанию точка
            end
            PredicateFunctionArgumentHeaders = [];//Заголовки аргументов функции предиката по умолчанию пустые
        else
            if type(nValues) == 10 then
                randomValuesFileName = nValues;
                csvSeparator = typeGenetate;
                csvDec = PredicateFunction;
                nValues = randomValuesMax;
                typeGenetate = 0;//Тип генерации по умолчанию ноль
                PredicateFunction = [];//Функция предиката по умолчанию пустая
                PredicateFunctionArgumentHeaders = [];//Заголовки аргументов функции предиката по умолчанию пустые
            else
                if type(typeGenetate) == 10 then
                    randomValuesFileName = typeGenetate;
                    csvSeparator = PredicateFunction;
                    typeGenetate = nValues;
                    nValues = randomValuesMax;
                    PredicateFunction = [];//Функция предиката по умолчанию пустая
                    PredicateFunctionArgumentHeaders = [];//Заголовки аргументов функции предиката по умолчанию пустые
                else
                    if IsCountFunction(nValues) then
                        PredicateFunction = nValues;
                        PredicateFunctionArgumentHeaders = typeGenetate;
                        typeGenetate = 0;//Тип генерации по умолчанию ноль
                    else
                        if type(PredicateFunction) == 10 then
                            randomValuesFileName = PredicateFunction;
                            PredicateFunction = typeGenetate;
                            typeGenetate = nValues;
                        end
                        PredicateFunctionArgumentHeaders = [];//Заголовки аргументов функции предиката по умолчанию пустые
                    end
                    nValues = randomValuesMax;
                    csvSeparator = ',';//.csv-разделитель по умолчанию запятая
                end
                csvDec = '.';//Десятичный разделитель по умолчанию точка
            end
            randomValuesMax = randomValuesMin;
            randomValuesMin = randomValuesHeaders;
            randomValuesHeaders = [];
        end
        isPredicateVectorized = %t;//По умолчанию предикат векторизован
    case 7 then
        if isempty(randomValuesHeaders) ||..
           (type(randomValuesHeaders) == 10) then
            if type(typeGenetate) == 10 then
                randomValuesFileName = typeGenetate;
                csvSeparator = PredicateFunction;
                csvDec = PredicateFunctionArgumentHeaders;
                typeGenetate = 0;//Тип генерации по умолчанию ноль
                PredicateFunction = [];//Функция предиката по умолчанию пустая
                PredicateFunctionArgumentHeaders = [];//Заголовки аргументов функции предиката по умолчанию пустые
            else
                if type(PredicateFunction) == 10 then
                    randomValuesFileName = PredicateFunction;
                    csvSeparator = PredicateFunctionArgumentHeaders;
                    PredicateFunction = [];//Функция предиката по умолчанию пустая
                    PredicateFunctionArgumentHeaders = [];//Заголовки аргументов функции предиката по умолчанию пустые
                else
                    if IsCountFunction(typeGenetate) then
                        randomValuesFileName = PredicateFunctionArgumentHeaders;
                        PredicateFunctionArgumentHeaders = PredicateFunction;
                        PredicateFunction = typeGenetate;
                        typeGenetate = 0;//Тип генерации по умолчанию ноль
                    else
                        randomValuesFileName = [];//Имя файла случайных величин по умолчанию пустое
                    end
                    csvSeparator = ',';//.csv-разделитель по умолчанию запятая
                end
                csvDec = '.';//Десятичный разделитель по умолчанию точка
            end
        else
            if IsCountFunction(nValues) then
                csvDec = randomValuesFileName;
                csvSeparator = PredicateFunctionArgumentHeaders;
                randomValuesFileName = PredicateFunction;
                PredicateFunctionArgumentHeaders = typeGenetate;
                PredicateFunction = nValues;
                typeGenetate = 0;//Тип генерации по умолчанию ноль
            elseif type(typeGenetate) == 10 then
                randomValuesFileName = typeGenetate;
                csvSeparator = PredicateFunction;
                csvDec = PredicateFunctionArgumentHeaders;
                typeGenetate = 0;//Тип генерации по умолчанию ноль
                PredicateFunction = [];//Функция предиката по умолчанию пустая
                PredicateFunctionArgumentHeaders = [];//Заголовки аргументов функции предиката по умолчанию пустые
            else
                csvSeparator = randomValuesFileName;
                randomValuesFileName = PredicateFunctionArgumentHeaders;
                PredicateFunctionArgumentHeaders = PredicateFunction;
                PredicateFunction = typeGenetate;
                typeGenetate = nValues;
                csvDec = '.';//Десятичный разделитель по умолчанию точка
            end
            nValues = randomValuesMax;
            randomValuesMax = randomValuesMin;
            randomValuesMin = randomValuesHeaders;
            randomValuesHeaders = [];
        end
        isPredicateVectorized = %t;//По умолчанию предикат векторизован
    case 8 then
        if isempty(randomValuesHeaders) ||..
           (type(randomValuesHeaders) == 10) then
            if IsCountFunction(typeGenetate) then
                csvSeparator = randomValuesFileName;
                randomValuesFileName = PredicateFunctionArgumentHeaders;
                PredicateFunctionArgumentHeaders = PredicateFunction;
                PredicateFunction = typeGenetate;
                typeGenetate = 0;//Тип генерации по умолчанию ноль
                csvDec = '.';//Десятичный разделитель по умолчанию точка
            elseif type(PredicateFunction) == 10 then
                csvDec = randomValuesFileName;
                csvSeparator = PredicateFunctionArgumentHeaders;
                randomValuesFileName = PredicateFunction;
                PredicateFunction = [];//Функция предиката по умолчанию пустая
                PredicateFunctionArgumentHeaders = [];//Заголовки аргументов функции предиката по умолчанию пустые
            else
                csvSeparator = ',';//.csv-разделитель по умолчанию запятая
                csvDec = '.';//Десятичный разделитель по умолчанию точка
            end
        else
            if IsCountFunction(nValues) then
                csvDec = randomValuesFileName;
                csvSeparator = PredicateFunctionArgumentHeaders;
                randomValuesFileName = PredicateFunction;
                PredicateFunctionArgumentHeaders = typeGenetate;
                PredicateFunction = nValues;
                typeGenetate = 0;//Тип генерации по умолчанию ноль
            else
                csvSeparator = randomValuesFileName;
                randomValuesFileName = PredicateFunctionArgumentHeaders;
                PredicateFunctionArgumentHeaders = PredicateFunction;
                PredicateFunction = typeGenetate;
                typeGenetate = nValues;
                csvDec = '.';//Десятичный разделитель по умолчанию точка
            end
            nValues = randomValuesMax;
            randomValuesMax = randomValuesMin;
            randomValuesMin = randomValuesHeaders;
            randomValuesHeaders = [];
        end
        isPredicateVectorized = %t;//По умолчанию предикат векторизован
    case 9 then
        if isempty(randomValuesHeaders) ||..
           (type(randomValuesHeaders) == 10) then
            if IsCountFunction(typeGenetate) then
                csvDec = csvSeparator;
                csvSeparator = randomValuesFileName;
                randomValuesFileName = PredicateFunctionArgumentHeaders;
                PredicateFunctionArgumentHeaders = PredicateFunction;
                PredicateFunction = typeGenetate;
                typeGenetate = 0;//Тип генерации по умолчанию ноль
            else
                csvDec = '.';//Десятичный разделитель по умолчанию точка
            end
        else
            csvDec = csvSeparator;
            csvSeparator = randomValuesFileName;
            randomValuesFileName = PredicateFunctionArgumentHeaders;
            PredicateFunctionArgumentHeaders = PredicateFunction;
            PredicateFunction = typeGenetate;
            typeGenetate = nValues;
            nValues = randomValuesMax;
            randomValuesMax = randomValuesMin;
            randomValuesMin = randomValuesHeaders;
            randomValuesHeaders = [];
        end
        isPredicateVectorized = %t;//По умолчанию предикат векторизован
    case 10 then
        if isempty(randomValuesHeaders) ||..
           (type(randomValuesHeaders) == 10) then
            if IsCountFunction(typeGenetate) then
                csvDec = csvSeparator;
                csvSeparator = randomValuesFileName;
                randomValuesFileName = PredicateFunctionArgumentHeaders;
                PredicateFunctionArgumentHeaders = PredicateFunction;
                PredicateFunction = typeGenetate;
                typeGenetate = 0;//Тип генерации по умолчанию ноль
            else
                csvDec = '.';//Десятичный разделитель по умолчанию точка
            end
            isPredicateVectorized = %t;//По умолчанию предикат векторизован
        else
            isPredicateVectorized = csvDec;
            csvDec = csvSeparator;
            csvSeparator = randomValuesFileName;
            randomValuesFileName = PredicateFunctionArgumentHeaders;
            PredicateFunctionArgumentHeaders = PredicateFunction;
            PredicateFunction = typeGenetate;
            typeGenetate = nValues;
            nValues = randomValuesMax;
            randomValuesMax = randomValuesMin;
            randomValuesMin = randomValuesHeaders;
            randomValuesHeaders = [];
        end
    end
    
    //Генерируем случайные значения
    [randomValues,..//Случайные величины
     randomValuesMin,..//Минимальные значения случайных величин
     randomValuesMax..//Максимальные значения случайных величин
     ]=RandomGenerateUniformOnRanges(randomValuesHeaders,..//Заголовки случайных величин
                                     randomValuesMin,..//Минимальные значения случайных величин
                                     randomValuesMax,..//Максимальные значения случайных величин
                                     nValues,..//Число сгенерированных совокупностей случайных величин
                                     typeGenetate,..//Тип генерации
                                     PredicateFunction,..//Функция предиката
                                     PredicateFunctionArgumentHeaders,..//Заголовки аргументов функции предиката
                                     isPredicateVectorized..//Векторизован ли предикат
                                     );
    
    //Сохраняем в .csv-файл
    if ~isempty(randomValuesFileName) then
        DatasToCSVFile(randomValues,randomValuesHeaders,%t,..
                       randomValuesFileName,csvSeparator,csvDec);
    end
endfunction
