//Получение данных из csv-текста
function [datas]=ReadNamesFromCSV(csvStrings,..//Стоки csv текста, которые нужно распарсить
                                  csvSeparator..//Разделитель csv
                                  )
    //Проверка аргументов
    select argn(2)
    case 0 then
        error('The function ReadNamesFromCSV takes 1 or 2 arguments');
    case 1 then
        csvSeparator = ',';//Разделитель csv по умолчанию запятая
    end
    
    //Проверка корректности аргументов
    if type(csvStrings) ~= 10 then
        error('The argument csvStrings of function ReadNamesFromCSV must be matrix of strings');
    end
    if (type(csvSeparator) ~= 10) ||..
       (size(csvSeparator,'*') > 1) then
       error('The argument csvSeparator of function ReadNamesFromCSV must be scalar string');
    end
    
    //Парсим
    if csvSeparator == '.' then
        csvDec = ',';
    else
        csvDec = '.';
    end
    datas = csvTextScan(csvStrings,csvSeparator,csvDec,'string');//Сканируем csv-текст
    datas = stripblanks(datas);//Удаляем пробелы
endfunction
