//Генерация случайных чисел на поддиапазонах с равномерным законом распределения
function [randomValuesHeaders,..//Заголовки случайных величин
          randomValuesMin,..//Минимальные значения случайных величин
          randomValuesMax..//Максимальные значения случайных величин
          ]=UniformRandomValuesAttributesParse(isHeaders,..//Факт наличия заголовков случайных данных
                                               UniformRandomValuesAttributesFileName,..//Имя файла аттрибутов равномерно распределенных случайных величин
                                               csvSeparator,..//.csv-разделитель
                                               csvDec..//Десятичный разделитель
                                               )
    //Проверяем агрументы
    select argn(2)
    case 0 then
        error('The function UniformRandomValuesAttributesParse takes 1, 2, 3 or 4 arguments');
    case 1 then
        UniformRandomValuesAttributesFileName = isHeaders;
        isHeaders = %t;//Загловок по умолчанию имеется
        csvSeparator = ',';//.csv-разделитель по умолчанию запятая
        csvDec = '.';//Десятичный разделитель по умолчанию точка
    case 2 then
        if type(isHeaders) == 4 then
            csvSeparator = ',';//.csv-разделитель по умолчанию запятая
        else
            csvSeparator = UniformRandomValuesAttributesFileName;
            UniformRandomValuesAttributesFileName = isHeaders;
            isHeaders = %t;//Загловок по умолчанию имеется
        end
        csvDec = '.';//Десятичный разделитель по умолчанию точка
    case 3 then
        if type(isHeaders) == 4 then
            csvDec = '.';//Десятичный разделитель по умолчанию точка
        else
            csvDec = csvSeparator;
            csvSeparator = UniformRandomValuesAttributesFileName;
            UniformRandomValuesAttributesFileName = isHeaders;
            isHeaders = %t;//Загловок по умолчанию имеется
        end
    end
    
    //Парсим файл
    [randomValuesAttributes,..//Аттрибуты случайных величин
     randomValuesHeaders..//Заголовки случайных величин
     ]=CSVFromFileToDatas(isHeaders,UniformRandomValuesAttributesFileName,..
                          csvSeparator,csvDec,%t);
    
    //Получаем границы минимальных и максимальных данных
    if NDatas(randomValuesAttributes) ~= 2 then
        error('The random values attributes including minimum and maximum values of this random values');
    end
    randomValuesMin = SelectionDatasSubset(randomValuesAttributes,1);//Минимальные значения случайных величин
    randomValuesMax = SelectionDatasSubset(randomValuesAttributes,2);//Максимальные значения случайных величин
endfunction
