//Генерация случайных чисел на поддиапазонах с равномерным законом распределения
function [nValues,..//Число сгенерированных совокупностей случайных величин
          typeGenetate,..//Тип генерации
          PredicateFunction,..//Функция предиката
          PredicateFunctionArgumentHeaders,..//Заголовки аргументов функции предиката
          isPredicateVectorized..//Векторизован ли предикат
          ]=UniformRandomValuesGenerateAttributesParse(UniformRandomValuesGenerateAttributesFileName,..//Имя файла аттрибутов равномерно распределенных случайных величин
                                                       csvSeparator..//.csv-разделитель
                                                       )
    //Проверяем агрументы
    [nRez,nArg] = argn();
    select nArg
    case 0 then
        UniformRandomValuesGenerateAttributesFileName = [];//Имя файла по умолчанию пустое
        csvSeparator = ',';//.csv-разделитель по умолчанию запятая
    case 1 then
        csvSeparator = ',';//.csv-разделитель по умолчанию запятая
    end
    
    //Обрабатываем случай пустого файла
    if isempty(UniformRandomValuesGenerateAttributesFileName) then
        nValues = 1;//Число сгенерированных совокупностей случайных величин
        typeGenetate = 0;//Тип генерации
        PredicateFunction = [];//Функция предиката
        PredicateFunctionArgumentHeaders = [];//Заголовки аргументов функции предиката
        
        //Выходим из функции
        return;
    end
    
    //Парсим файл
    [GenerateAttributes,..//Аттрибуты генерации случайных величин
     GenerateAttributesHeaders..//Заголовки аттрибутов генерации случайных величин
     ]=CSVFromFileToDatas(%t,UniformRandomValuesGenerateAttributesFileName,..
                          csvSeparator,'.',%f);
    if NDatas(GenerateAttributes) ~= 1 then
        error('The generation uniform random datas takes 1 aggregate of attributes');
    end
    
    //Получаем аттрибуты генерации случайных величин
    nValues = SelectionDatas(GenerateAttributesHeaders,..
                             "NValues",..
                             GenerateAttributes);
    if isempty(nValues) then
        nValues = 1;//По умолчанию число величин равно 1
    else
        nValues = evstr(nValues);
    end
    if nRez > 1 then
        typeGenetate = SelectionDatas(GenerateAttributesHeaders,..
                                      "TypeGenerate",..
                                      GenerateAttributes);
        if isempty(typeGenetate) then
            typeGenetate = 0;
        else
            typeGenetate = evstr(typeGenetate);
        end
    end
    if nRez > 2 then
        PredicateFunction = SelectionDatas(GenerateAttributesHeaders,..
                                           "PredicateFunction",..
                                           GenerateAttributes);
        if ~isempty(PredicateFunction) then
            //Выделяем параметры функции
            PredicateFunctionParametrs = SelectionDatas(GenerateAttributesHeaders,..
                                                        "PredicateFunctionParametrs",..
                                                        GenerateAttributes);
            
            //Формируем функцию или список функции с параметрами
            if isempty(PredicateFunctionParametrs) then
                //Получаем указатель на функцию
                execstr('PredicateFunction = ' + PredicateFunction);
            else
                PredicateFunctionParametrs = ReadNamesFromCSV(PredicateFunctionParametrs,..
                                                             csvSeparator);//Вычленяем параметры функции предиката
                
                //Получаем список параметров функции
                PredicateFunction = evstr('list(' + PredicateFunction + ',' + strcat(PredicateFunctionParametrs,',') + ')');
            end
        end
    end
    if nRez > 3 then
        PredicateFunctionArgumentHeaders = SelectionDatas(GenerateAttributesHeaders,..
                                                          "PredicateFunctionArgumentHeaders",..
                                                          GenerateAttributes);
        if ~isempty(PredicateFunctionArgumentHeaders) then
            PredicateFunctionArgumentHeaders = ReadNamesFromCSV(PredicateFunctionArgumentHeaders,..
                                                               csvSeparator);
        end
    end
    if nRez > 4 then
        isPredicateVectorized = SelectionDatas(GenerateAttributesHeaders,..
                                               "IsVectorized",..
                                               GenerateAttributes);
        if isempty(isPredicateVectorized) then
            isPredicateVectorized = %t;//По умолчанию предикат векторизован
        else
            select isPredicateVectorized
            case "0" then
                isPredicateVectorized = %f;
            case "1" then
                isPredicateVectorized = %t;
            else
                error('The attribute IsVectorized must be 0 or 1');
            end
        end
    end
endfunction
